#!/usr/bin/perl
 
########################################################################
# COPYRIGHT NOTICE:
#
# Copyright 2008 FocalMedia.Net All Rights Reserved.
#
# Selling the code for this program without prior written consent 
# from FocalMedia.Net is expressly forbidden. You may not 
# redistribute this program in any shape or form.
# 
# This program is distributed "as is" and without warranty of any
# kind, either express or implied. In no event shall the liability 
# of FocalMedia.Net for any damages, losses and/or causes of action 
# exceed the total amount paid by the user for this software.
#
########################################################################

#### EDIT HERE -- FOR WINDOWS/IIS BASED INSTALLATIONS ONLY #######

$config_cgi = "config.cgi"; ## <-- CHANGE THIS LINE TO THE FULL SERVER PATH TO config.cgi

# THE PATH ON A WINDOWS INSTALLATION WILL LOOK SOMETHING LIKE THIS:
# $config_cgi = "c:/inetpub/webpub/cgi-bin/pseek/config.cgi";

#### DO NOT CHANGE ANYTHING BELOW THIS LINE #################


#use FindBin;
#use lib $FindBin::Bin;

use CGI::Carp qw(fatalsToBrowser); 
use CGI;
use DBI;
use pseek;
use psfp;
use fmspm;


&get_setup;
fmspm::check_spamb("p_ml.cgi", "header", "$data_dir");
$q = CGI->new;

################# 
print "Content-type: text/html\n\n"; 


### CHECK IMAGE AUTHENTICATION
$img_auth_check = pseek::check_img_auth;
if ($img_auth_check eq "false") 
{

$prb = pseek::get_file_contents("$data_dir/formmail_prb.html");

$addurltext = pseek::get_file_contents("$data_dir/addurl2.txt");
@ctexts = split (/\n/, $addurltext);

$prb =~ s/%%problem%%/$ctexts[15]/gi;
$prb =~ s/!build_url!/$web_url/g;
$prb =~ s/!!build_url!!/$web_url/g;
$prb = pseek::ts_insert_template_includes($prb);
$prb = pseek::fill_vars($prb); 

print $prb; 

exit;

}



### CHECK FOR ERRORS

$from_name = $q->param('from_name');
$from_email = $q->param('from_email');
$subject = $q->param('subject');
$message = $q->param('message');


open (FORMMA, "$data_dir/formmailresp.dat");
	@presponse = <FORMMA>;
close (FORMMA);


if ($from_email eq "") { $error_text = $presponse[0]; }
if ($from_name eq "") { $error_text = $presponse[1]; }
if ($subject eq "") { $error_text = $presponse[2]; }
if ($message eq "") { $error_text = $presponse[3]; }

if ($error_text ne "")
	{
	$prb = pseek::get_file_contents("$data_dir/formmail_prb.html");
	
	$prb =~ s/%%problem%%/$error_text/gi;
	
	$prb = pseek::ts_insert_template_includes($prb);
	$prb = pseek::fill_vars($prb); 
	
	print $prb;
	exit;
	}



### SEND EMAIL

$lnkid = $q->param('id'); $lnkid =~ s/[^0-9]//g;
if ($lnkid eq "") { print "The email form is not configured correctly. Please follow the setup instructions of the form mail plugin exactly."; exit; }

if ($mysql_hostname eq ""){$dsn = "DBI:mysql:$db_name";}else{$dsn = "DBI:mysql:$db_name:$mysql_hostname:$mysql_port";}
$dbh = DBI->connect($dsn, $db_username, $db_password);
if ( !defined $dbh ) {die "Cannot connect to MySQL server: $DBI::errstr\n"; }

$sql = "SELECT email FROM links WHERE lnkid = '$lnkid'";
$sth = $dbh->prepare($sql);
$sth->execute;
$serror = ""; $serror = $sth->errstr; if ($serror ne "") {die "SQL Syntax Error: $serror \n From: $sql";}
$rows = $sth->rows();
if ($rows < 1) { print "Link not found."; exit; }

while ( @row = $sth->fetchrow() )
	{ 
	$email = $row[0];
	}


if (($email eq "") and (length($presponse[5]) < 2))
	{
	$prb = pseek::get_file_contents("$data_dir/formmail_prb.html");
	$prb =~ s/%%problem%%/$presponse[4]/gi;
	$prb = pseek::ts_insert_template_includes($prb);
	$prb = pseek::fill_vars($prb); 
	print $prb;
	$sth->finish;
	$dbh->disconnect;
	exit;
	}

if (($email eq "") and (length($presponse[5]) > 2))
	{
	$email = $presponse[5];
	}


$hf_data = pseek::get_file_contents("$data_dir/formailcust.dat");
($header, $footer) = split (/::::o::::-::::/, $hf_data);

$message = $header . $message . $footer;

pseek::send_email ($from_name, $from_email, $email, $subject, $message); 

$sth->finish;
$dbh->disconnect;


$sstmpl = pseek::get_file_contents("$data_dir/formmail_succ.html");
$sstmpl = pseek::ts_insert_template_includes($sstmpl);
$sstmpl = pseek::fill_vars($sstmpl); 
print $sstmpl;





#################

sub get_setup
{

$exists = (-e "$config_cgi");
if ($exists > 0)
	{
	open (STP, "$config_cgi");
		while (defined($line=<STP>))
			{
			if ($line =~ m/#/g)
				{
				$r = pos($line);
				$line = substr($line, 0, $r - 1);
				}
				
				$line =~ s/\n//g;
	
if ($line =~ /^DB_NAME/){$db_name = &get_setup_line($line, DB_NAME);}
if ($line =~ /^DB_USERNAME/){$db_username = &get_setup_line($line, DB_USERNAME);}
if ($line =~ /^DB_PASSWORD/){$db_password = &get_setup_line($line, DB_PASSWORD);}
if ($line =~ /^MYSQL_HOSTNAME/){$mysql_hostname = &get_setup_line($line, MYSQL_HOSTNAME);}
if ($line =~ /^MYSQL_PORT/){$mysql_port = &get_setup_line($line, MYSQL_PORT);}

if ($line =~ /^SCRIPT_URL/){$script_url = &get_setup_line($line, SCRIPT_URL);}
if ($line =~ /^ADMIN_URL/){$admin_url = &get_setup_line($line, ADMIN_URL);}
if ($line =~ /^WEB_URL/){$web_url = &get_setup_line($line, WEB_URL);}
if ($line =~ /^WEB_DIR/){$web_dir = &get_setup_line($line, WEB_DIR);}
if ($line =~ /^DATA_DIR/){$data_dir = &get_setup_line($line, DATA_DIR);}

if ($line =~ /^USERNAME/){$username = &get_setup_line($line, USERNAME);}
if ($line =~ /^PASSWORD/){$password = &get_setup_line($line, PASSWORD);}


			}
	close (STP);
	
	}
}




sub get_setup_line
{
my ($setup_line, $setup_var) = @_;
$crit = "\"";
$setup_line =~ m/$crit/g;
$r1 = pos($setup_line);
$setup_line =~ m/$crit/g;
$r2 = pos($setup_line);
$setup_line = substr($setup_line, $r1, ($r2 - $r1 - 1));
$return_val = $setup_line;
return ($return_val);
}

#### END CONFIGURATION ########################################################

